Shadowsocks 一键安装脚本(四合一)

技术 1722311 次围观 1320 次吐槽

本脚本适用环境

系统支持:CentOS 6+,Debian 7+,Ubuntu 12+
内存要求:≥128M
日期  :2019 年 01 月 11 日

关于本脚本

1、一键安装 Shadowsocks-Python, ShadowsocksR, Shadowsocks-Go, Shadowsocks-libev 版(四选一)服务端;
2、各版本的启动脚本及配置文件名不再重合;
3、每次运行可安装一种版本;
4、支持以多次运行来安装多个版本,且各个版本可以共存(注意端口号需设成不同);
5、若已安装多个版本,则卸载时也需多次运行(每次卸载一种);

友情提示:如果你有问题,请先阅读这篇《Shadowsocks Troubleshooting》之后再询问。

默认配置

服务器端口:自己设定(如不设定,默认从 9000-19999 之间随机生成)
密码:自己设定(如不设定,默认为 teddysun.com)
加密方式:自己设定(如不设定,Python 和 libev 版默认为 aes-256-gcm,R 和 Go 版默认为 aes-256-cfb)
协议(protocol):自己设定(如不设定,默认为 origin)(仅限 ShadowsocksR 版)
混淆(obfs):自己设定(如不设定,默认为 plain)(仅限 ShadowsocksR 版)
备注:脚本默认创建单用户配置文件,如需配置多用户,请手动修改相应的配置文件后重启即可。

客户端下载

常规版 Windows 客户端
https://github.com/shadowsocks/shadowsocks-windows/releases

ShadowsocksR 版 Windows 客户端
https://github.com/shadowsocksrr/shadowsocksr-csharp/releases

使用方法

使用root用户登录,运行以下命令:

wget --no-check-certificate -O shadowsocks-all.sh https://raw.githubusercontent.com/teddysun/shadowsocks_install/master/shadowsocks-all.sh
chmod +x shadowsocks-all.sh
./shadowsocks-all.sh 2>&1 | tee shadowsocks-all.log

安装完成后,脚本提示如下

Congratulations, your_shadowsocks_version install completed!
Your Server IP        :your_server_ip
Your Server Port      :your_server_port
Your Password         :your_password
Your Encryption Method:your_encryption_method

Your QR Code: (For Shadowsocks Windows, OSX, Android and iOS clients)
 ss://your_encryption_method:[email protected]_server_ip:your_server_port
Your QR Code has been saved as a PNG file path:
 your_path.png

Welcome to visit:https://teddysun.com/486.html
Enjoy it!

卸载方法

若已安装多个版本,则卸载时也需多次运行(每次卸载一种)

使用root用户登录,运行以下命令:

./shadowsocks-all.sh uninstall

启动脚本

启动脚本后面的参数含义,从左至右依次为:启动,停止,重启,查看状态。

Shadowsocks-Python 版:
/etc/init.d/shadowsocks-python start | stop | restart | status

ShadowsocksR 版:
/etc/init.d/shadowsocks-r start | stop | restart | status

Shadowsocks-Go 版:
/etc/init.d/shadowsocks-go start | stop | restart | status

Shadowsocks-libev 版:
/etc/init.d/shadowsocks-libev start | stop | restart | status

各版本默认配置文件

Shadowsocks-Python 版:
/etc/shadowsocks-python/config.json

ShadowsocksR 版:
/etc/shadowsocks-r/config.json

Shadowsocks-Go 版:
/etc/shadowsocks-go/config.json

Shadowsocks-libev 版:
/etc/shadowsocks-libev/config.json

更新日志

2019 年 01 月 11 日:
1、升级:libsodium 到最新版本 1.0.17;
2、升级:mbedtls 到最新版本 2.16.0;

2018 年 11 月 05 日:
1、升级:使用 Github 上最新代码编译出 Go 版二进制可执行文件,版本号 1.2.2。

2018 年 06 月 01 日:
1、修正:在启用了插件 simple-obfs 的情况下,libev 版启动失败的问题;
2、修正:在使用 /etc/init.d/shadowsocks-libev restart 命令重启 libev 版服务端时,偶尔出现的 “bind: Address already in use” 问题;
3、修正:移除 libev 版配置文件中的 local_address 字段;
4、修改:不再默认使用 root 用户启动,改为使用 nobody 用户启动 libev 版服务端 ss-server;
5、升级:mbedtls 到版本 2.9.0;
6、修改:libev 版启动脚本中的 -u 参数(即同时启用 TCP 和 UDP 模式),改到配置文件里配置为 “mode”: “tcp_and_udp”;
7、修改:libev 版配置文件的内置 NameServers 为 8.8.8.8,默认是从 /etc/resolv.conf 中取得。

2018 年 02 月 07 日:
1、修改:将默认端口从 8989 改为从 9000-19999 之间随机生成。

2018 年 02 月 06 日:
1、修改:ShadowsocksR 版为 ShadowsocksRR 最新版;
2、新增:ShadowsocksR 版的协议(protocol)增加了 4 个,分别为:

auth_chain_c
auth_chain_d
auth_chain_e
auth_chain_f

2017 年 12 月 29 日:
1、升级:libsodium 到 1.0.16。

2017 年 11 月 25 日:
1、如果 Linux 内核版本大于 3.7.0,则配置文件默认支持 TCP fast open;
2、新增:libev 版启动时支持 verbose mode,也就是默认写 log 到 /var/log/messages 方便查看。

2017 年 11 月 12 日:
1、新增生成 ss:// 或 ssr:// 链接,以及其二维码图片。
※ 脚本会根据当前安装的版本以及输入的各项配置,自动生成 ss:// 或 ssr:// 的链接并在安装成功后显示,直接复制即可被客户端识别。同时生成其二维码图片,并保存在当前目录下,下载后用看图软件打开,也能被客户端识别。

复制二维码链接后 Shadowsocks 客户端识别示例:

复制二维码链接后 ShadowsocksR 客户端识别示例:

二维码(QR Code)参考链接:
https://github.com/shadowsocks/shadowsocks/wiki/Generate-QR-Code-for-Android-or-iOS-Clients
https://github.com/shadowsocksr-backup/shadowsocks-rss/wiki/SSR-QRcode-scheme

2017 年 10 月 22 日:
1、升级:libsodium 到 1.0.15。

2017 年 10 月 14 日:
1、新增:在安装 Shadowsocks-libev 版时可选安装 simple-obfs 服务端。
※ 脚本通过判断 autoconf 版本是否大于或等于 2.67 来一键安装 simple-obfs 服务端。并且,支持在安装过程中选择 obfs 为 http 或 tls。
※ 使用方法参考:https://teddysun.com/511.html

2017 年 09 月 16 日:
1、修正:Shadowsocks-libev 版 v3.1.0 使用 libc-ares 替换 libudns 依赖包,解决了依赖问题;
2、升级:mbedtls 到版本 2.6.0。

2017 年 07 月 27 日:
1、新增:ShadowsocksR 版可选协议(protocol)auth_chain_b 。使用该协议需更新到最新(4.7.0) ShadowsocksR 版客户端
2、修改:更新 ShadowsocksR 源码下载地址。

2017 年 07 月 23 日:
1、修正:卸载时可自行选择某个版本卸载,若该版本不存在则报错退出。

2017 年 07 月 22 日:
1、修正:默认加密方式从 aes-256-cfb 改为 aes-256-gcm(Python 和 libev 版);
2、新增:安装时可选 16 种加密方式的其中之一(Python 和 libev 版)。如下所示:

aes-256-gcm
aes-192-gcm
aes-128-gcm
aes-256-ctr
aes-192-ctr
aes-128-ctr
aes-256-cfb
aes-192-cfb
aes-128-cfb
camellia-128-cfb
camellia-192-cfb
camellia-256-cfb
chacha20-ietf-poly1305
chacha20-ietf
chacha20
rc4-md5

3、新增:安装时可选 9 种加密方式的其中之一(Go 版)。如下所示:

aes-256-cfb
aes-192-cfb
aes-128-cfb
aes-256-ctr
aes-192-ctr
aes-128-ctr
chacha20-ietf
chacha20
rc4-md5

4、新增:安装时可选 15 种加密方式的其中之一(none 是不加密,ShadowsocksR 版)。如下所示:

none
aes-256-cfb
aes-192-cfb
aes-128-cfb
aes-256-cfb8
aes-192-cfb8
aes-128-cfb8
aes-256-ctr
aes-192-ctr
aes-128-ctr
chacha20-ietf
chacha20
salsa20
xchacha20
xsalsa20
rc4-md5

5、新增:安装时可选 7 种协议(protocol)的其中之一(仅限 ShadowsocksR 版)。如下所示:

origin
verify_deflate
auth_sha1_v4
auth_sha1_v4_compatible
auth_aes128_md5
auth_aes128_sha1
auth_chain_a
auth_chain_b

6、新增:安装时可选 9 种混淆(obfs)的其中之一(仅限 ShadowsocksR 版)。如下所示:

plain
http_simple
http_simple_compatible
http_post
http_post_compatible
tls1.2_ticket_auth
tls1.2_ticket_auth_compatible
tls1.2_ticket_fastauth
tls1.2_ticket_fastauth_compatible

2017 年 02 月 24 日:
1、恢复: 通过 Github API 自动获取 Shadowsocks-libev 的最新 release 版本的功能(v3.0.3)。

2017 年 02 月 13 日:
1、升级: Shadowsocks-libev 版到版本 3.0.2;
2、升级: Shadowsocks-go 版到版本 1.2.1(基于 Github 最新代码,用 go 1.8 编译完成的 x86 和 x86_64 二进制文件);
3、修复:在 Debian 7 下默认没有 libudns-dev 依赖包的问题。

2017 年 02 月 12 日:
1、升级: Shadowsocks-libev 版到版本 3.0.1。

2017 年 01 月 27 日:
1、升级: Shadowsocks-go 版到版本 1.2.1 (仅适用于 x86_64 系统)

更多单版本 Shadowsocks 服务端一键安装脚本

Shadowsocks Python 版一键安装脚本(CentOS,Debian,Ubuntu)
ShadowsocksR 版一键安装脚本(CentOS,Debian,Ubuntu)
CentOS 下 Shadowsocks-libev 一键安装脚本
Debian 下 Shadowsocks-libev 一键安装脚本
Shadowsocks-go 一键安装脚本(CentOS,Debian,Ubuntu)

注意:以上单版本不可与该四合一版本混用。

转载请注明:秋水逸冰 » Shadowsocks 一键安装脚本(四合一)

发表评论
取消评论
  • 昵称 (必填)
  • 邮箱 (必填)
  • 网址
表情

已有评论 (1320)

  1. 一键四合一脚本不可以把加密方式改成 chacha20 了吗?
    hispi2年前 (2017-03-08)回复
  2. https://shadowsocks.be/9.html 按照里面说的,SSR配置了多用户,新开的端口,连不上。。。iptables 或 firewalld不会配置。。。但是搜了下iptables和firewalld的配置文件,端口都是空的,之前安装时设定的端口也没有在iptables和firewalld里存在
    动动我试试2年前 (2017-03-07)回复
  3. 请问,可以下载,安装时显示 Permission denied 是什么原因?谢谢!
    vin2年前 (2017-03-06)回复
  4. 全部搞完了,可以正常使用,就是还是有一些网站没法访问,怀疑是DNS的问题,有办法解决吗?谢谢了
    hehehehehehe2年前 (2017-03-05)回复
  5. 解决了。占用2.73G太大了。
    hiblog2年前 (2017-03-04)回复
  6. 请问这个合集哪个版本最靠谱,最稳定!
    联辰琪康2年前 (2017-03-04)回复
  7. E: You don't have enough free space in /var/cache/apt/archives/. Error: Failed to install asciidoc Please visit our website: https://teddysun.com/486.html for help 我剩余空间本来还有1.5G的。。。安装这个4合一1.5G吃没了。导致安装失败。。。
    hiblog2年前 (2017-03-04)回复
  8. E: You don't have enough free space in /var/cache/apt/archives/. Error: Failed to install asciidoc Please visit our website: https://teddysun.com/486.html for help 怎么弄?
    hiblog2年前 (2017-03-04)回复
  9. 新手看不懂呀
    afgef2年前 (2017-03-03)回复
  10. Resolving raw.githubusercontent.com... 151.101.100.133 Connecting to raw.githubusercontent.com|151.101.100.133|:443... failed: Connection timed out. Retrying. --2017-03-03 03:26:35-- (try: 2) https://raw.githubusercontent.com/teddysun/shadowsocks_install/master/shadowsocks-all.sh Connecting to raw.githubusercontent.com|151.101.100.133|:443...
    12年前 (2017-03-03)回复
  11. vultr 上会提示没有 setuptools 需要先 export LC_ALL=C 再装 setuptools 再跑你的脚本,修改下吧
    gladuo2年前 (2017-03-01)回复
  12. 你好,AWS没有udns-devel这个包,yum install不了 从www.corpit.ru下载了make后放到/usr/local 然后在 /etc/ld.so.conf.d/下增加了udns.conf并添加/usr/local/udns 然后ldconfig 但编译时还是报没有找到udns.h,请问可能是哪里有问题?
    雪落无垠2年前 (2017-03-01)回复
    • yum install -y epel-release 然后就有 udns-devel 这个包了。
      秋水逸冰2年前 (2017-03-03)回复
      • Loading mirror speeds from cached hostfile * base: repo1.sea.innoscale.net * elrepo: ftp.yz.yamagata-u.ac.jp * extras: repo1.sea.innoscale.net * updates: repo1.sea.innoscale.net Package gettext-devel-0.18.2.1-4.el7.x86_64 already installed and latest version Nothing to do Loaded plugins: fastestmirror Loading mirror speeds from cached hostfile * base: repo1.sea.innoscale.net * elrepo: ftp.yz.yamagata-u.ac.jp * extras: repo1.sea.innoscale.net * updates: repo1.sea.innoscale.net Package asciidoc-8.6.8-5.el7.noarch already installed and latest version Nothing to do Loaded plugins: fastestmirror Loading mirror speeds from cached hostfile * base: repo1.sea.innoscale.net * elrepo: ftp.yz.yamagata-u.ac.jp * extras: repo1.sea.innoscale.net * updates: repo1.sea.innoscale.net No package udns-devel available. Error: Nothing to do Error: Failed to install udns-devel Please visit our website: https://teddysun.com/486.html for help [[email protected] ~]# 这个是什么情况呢
        卡神网2年前 (2017-03-24)回复
        • 表示有一个包 udns-devel 安装失败。 由于 udns-devel 是在 epel repo 里,所以,请检查 epel 是否成功安装。或者使用如下命令手动安装 epel yum -y install epel-release
          秋水逸冰2年前 (2017-03-26)回复
          • [[email protected] ~]# yum -y install epel-release Loaded plugins: fastestmirror Loading mirror speeds from cached hostfile * base: centos-distro.cavecreek.net * elrepo-kernel: repos.lax-noc.com * extras: mirrors.usc.edu * updates: mirror.sigmanet.com Package epel-release-7-9.noarch already installed and latest version Nothing to do 再次安装还是提示 No package udns-devel available. Error: Nothing to do Error: Failed to install udns-devel Please visit our website: https://teddysun.com/486.html for help
            shawn2年前 (2017-04-15)回复
    • sudo wget -O /etc/yum.repos.d/CentOS-Base.repo http://mirrors.aliyun.com/repo/Centos-6.repo sudo wget -O /etc/yum.repos.d/MirrorBrain.repo http://download.opensuse.org/repositories/home:/michalstrnad/CentOS_CentOS-6/home:michalstrnad.repo sudo yum install udns-devel
      屁兔2年前 (2017-05-23)回复
  13. ssr的一键安装里到底需要装什么?每次在debian8上运行都会安装跟texlive相关的一系列东西,不知道其它发型版有没有类似问题。
    gigis2年前 (2017-02-28)回复
  14. 在kvm内核512m ram的VPS上Debian7 64上,装了三个版本除了go版本以外,并且安装锐速,效果不太一样。油管都能在3M以上,python版本的SS能跑到15M,多谢版主帮助。
    tim2年前 (2017-02-27)回复
  15. 完全复制命令过去的,但安装不成功(Google Cloud Platform, Cent OS7),具体信息如下,请问如何解决? Connected, host fingerprint: ssh-rsa 2048 19:86:4E:9D:78:D6:48:16:C2:FF:FC:**:**:**:**:**:**:**:**:** Last login: Sun Feb 26 08:12:28 2017 from **.**.**.** [***@instance-1 ~]$ wget --no-check-certificate https://raw.githubusercontent.com/teddysun/shadowsocks_install/master/shadowsocks.sh -bash: wget: command not found [***@instance-1 ~]$ chmod +x shadowsocks.sh chmod: cannot access ‘shadowsocks.sh’: No such file or directory [***@instance-1 ~]$ ./shadowsocks.sh 2>&1 | tee shadowsocks.log
    ccyborg2年前 (2017-02-26)回复